module Main( main ) where

import System( getArgs )
import System.IO
import System.IO.Unsafe
import Control.Exception
import Control.Concurrent
import Control.Monad

multipliers :: MVar [MVar Integer]
multipliers = unsafePerformIO (newMVar [])

waitForMultiplier :: [Integer] -> IO ([Integer])
waitForMultiplier intlist = do
  cs <- takeMVar multipliers
  case cs of
    []   -> return (intlist)
    m:ms -> do
            putMVar multipliers ms
            i <- takeMVar m
            il <- return (intlist ++ [i])
            waitForMultiplier il

forkMultiplier  :: [Integer] -> IO ThreadId
forkMultiplier intlist
  = do
    mvar <- newEmptyMVar
    multiplierlist <- takeMVar multipliers
    putMVar multipliers (mvar:multiplierlist)
    forkOS (multiply_proc mvar intlist)

multiply_proc :: MVar Integer -> [Integer] -> IO ()
multiply_proc mvar intlist
  = do
    res <- multiply intlist
    putMVar mvar res
    return ()
    where
      multiply intlist = multiply' intlist 1
        where
          multiply' (x:xs) aggregate = do multiply' xs (aggregate * x)
          multiply' [] aggregate     = return (aggregate)

main =
   do
    args      <- getArgs
    argHead   <- return ( head args )
    to        <- return ( read argHead )
    chunks    <- generateChunks to
    mapM_ mapChunks chunks
    intlist   <- waitForMultiplier []
    res       <- return (reduce intlist)
    hPrint stdout res
    return ()
    where
      generateChunks to = do
                          res <- return ([ [x | x <- [3..to], odd x] , [x | x <- [2..to], even x] ])
                          return res
      mapChunks intlist = forkMultiplier intlist
      reduce intlist = foldl (*) 1 intlist